%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% FUNCTION: [stop, fvallist] = scopt_fx_terminate(fval, fvallist, n, tol)
%%% PURPOSE: Check if the objective value is changed significantly.
%%% INFORMATION:
%%%    By Quoc Tran Dinh, Laboratory for Informations and Inference Systems,
%%%       (LIONS), EPFL, Lausanne, Switzerland.
%%%    Joint work with Volkan Cevher and Anastasios Kyrillidis.
%%%    Date: 03.06.2013.
%%%    Last modified: 03.06.2013.
%%%    Contact: quoc.trandinh@epfl.ch
%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [stop, fvallist] = scopt_fx_terminate(fval, fvallist, n, tol)

stop = false;
if length(fvallist) >= n
    n_count = 0;
    for k = 1: length(fvallist)
        if abs(fval - fvallist(k)) <= tol*max(abs(fval), 1)
            n_count = n_count + 1;
        end
    end
    if n_count == length(fvallist), stop = true; end
    fvallist = [];
else
    fvallist = [fvallist; fval];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% END OF THE IMPLEMENTATION.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
